/******************************************************************************
*
* project name:    TIGCC Tools Suite 
* file name:       tt.h
* initial date:    13/08/2000
* author:          thomas.nussbaumer@gmx.net 
* description:     generic definitions for TIGCC Tools Suite
*
******************************************************************************/

/*
  This file is part of the TIGCC Tools Suite.

  This file is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  As a special exception, UNMODIFIED copies of some TIGCC Tools Suite utilities
  may also be redistributed or sold without source code, for any purpose. (The
  Lesser General Public License restrictions do apply in other respects; for
  example, they cover modification of the program.) Please refer to the main
  source file for the individual utility as to whether this is the case for a
  particular tool. This exception notice must be removed on modified copies of
  this file.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef __TT_H__
#define __TT_H__

#define CALC_TI89    0
#define CALC_TI92P   1

#define SIGNATURE_TI89   "**TI89**"
#define SIGNATURE_TI92P  "**TI92P*" 

#define DEFAULT_FOLDER   "main"

#define DEFAULT_ITEMS_PER_LINE  10

#endif

//#############################################################################
//###################### NO MORE FAKES BEYOND THIS LINE #######################
//#############################################################################
//
//=============================================================================
// Revision History
//=============================================================================
//
// Revision 1.3  2000/08/23 20:29:43  Thomas Nussbaumer
// added a 'P' to the TI92p definitions
//
// Revision 1.2  2000/08/23 01:04:41  Thomas Nussbaumer
// corrected signature of TI92p
//
// Revision 1.1  2000/08/13 20:24:16  Thomas Nussbaumer
// initial version
//
//
//
//
